# -*- coding: iso-8859-15 -*-


"""
    Copyright (C) 2004 Paul Brauner <polux2001@wanadoo.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""



import re, os, time
import codecs
from generated import contactDialog
from qt import *
from kdeui import *
from kdecore import KApplication
import dcopext, dcop

re_nom_prenom = re.compile(r'N:([\S ]*);([\S ]*);;;')
re_tel_home = re.compile(r'TEL;TYPE=HOME:([0-9 ]+)')
re_tel_cell = re.compile(r'TEL;TYPE=CELL:([0-9 ]+)')
re_email = re.compile(r'EMAIL:(\S+)')
re_nick = re.compile(r'NICKNAME:(\S+)')
re_uid = re.compile(r'UID:(\S+)')

class Contact(KListViewItem):
    def __init__(self, *args):
        QListViewItem.__init__(self, *args)
        self.info = {"nom" : "noname", "prenom" : "noname"}
        
    def text(self, column):
        if self.info.has_key("nom") and self.info.has_key("prenom"):
            return "%s %s" % (self.info["nom"], self.info["prenom"])
        elif self.info.has_key("nom"):
            return self.info["nom"]
        elif self.info.has_key("prenom"):
            return self.info["prenom"]

    def formattedInfo(self):
        i = self.info
        s = QString()
        if i.has_key("prenom"):
            s += u"<b>Prnom : </b>%s<br>" % i["prenom"]
        if i.has_key("nom"):
            s += u"<b>Nom : </b>%s<br>" % i["nom"]
        if i.has_key("nick"):
            s += u"<b>Surnom : </b>%s<br>" % i["nick"]
        s += "<br>"
        if i.has_key("email"):
            s += u'<b>Email : </b><a href="mailto:%(mail)s">%(mail)s</a><br>' % {"mail" : i["email"]}
        s += "<br>"
        if i.has_key("tel_home"):
            s += u"<b>Tlphone fixe : </b>%s<br>" % i["tel_home"]
        if i.has_key("tel_portable"):
            s += u"<b>Tlphone portable : </b>%s<br>" % i["tel_portable"]
        return s
                    
class Contacts:
    def __init__(self, parent):
        self.bodies = []
        f = codecs.open(os.environ['HOME'] + "/.kde/share/apps/kabc/std.vcf",'r', 'utf-8')
        l = f.next()
        while 1:
            ok = False
            try:
                while not "BEGIN:VCARD" in l:
                    l = f.next()        
                        
                info = {}
                l = f.next()            
                
                while not "END:VCARD" in l:
                
                    res1 = re_nom_prenom.search(l)
                    res2 = re_tel_home.search(l)
                    res3 = re_tel_cell.search(l)
                    res4 = re_email.search(l)
                    res5 = re_nick.search(l)
                    res6 = re_uid.search(l)
                    
                    if res1:
                        if res1.group(1):
                            info["nom"] = res1.group(1)
                        if res1.group(2):
                            info["prenom"] = res1.group(2)
                        if res1.groups() != ("",""):
                            ok = True
                    elif res2:
                        info["tel_home"] = res2.group(1)
                    elif res3:
                        info["tel_portable"] = res3.group(1)
                    elif res4:
                        info["email"] = res4.group(1)
                    elif res5:
                        info["nick"] = res5.group(1)
                    elif res6:
                        info["uid"] = res6.group(1)
                    
                    l = f.next()
                    
                if ok:
                    c = Contact(parent)
                    c.info = info
                    self.bodies.append(c)
                l = f.next()
                
            except (StopIteration):
                return

class contactDialogImpl(contactDialog):
    def __init__(self):
        contactDialog.__init__(self,None,"", Qt.WStyle_Customize | Qt.WStyle_NoBorder |Qt.WType_TopLevel | Qt.WDestructiveClose | Qt.WStyle_StaysOnTop)

        #style du cardre :
        #self.setFrameStyle(QFrame.Box | QFrame.Plain)
        
        # remplissage de la liste 
        self.update()
        
        #connexions
        self.connect(self.contactList,SIGNAL("selectionChanged(QListViewItem*)"),self.fillInfo)
        self.connect(self.searchField,SIGNAL("textChanged(const QString&)"),self.filterContacts)
        self.connect(self.contactList,SIGNAL("selectionChanged(QListViewItem*)"),self.updateListPos)
        self.connect(self.editButton,SIGNAL("pressed()"),self.editContact)
        
        #initialisations
        self.searchField.setFocus()

    def update(self):
        print "aaaaaa"
        self.contactList.clear()
        self.contacts = Contacts(self.contactList)
        self.contactList.setSelected(self.contactList.firstChild(),1)
        
    def keyPressEvent(self, e):
        if e.key() == Qt.Key_Up:
            self.contactList.setSelected(self.contactList.selectedItem().itemAbove(),1)
        if e.key() == Qt.Key_Down:
            self.contactList.setSelected(self.contactList.selectedItem().itemBelow(),1)
        if e.key() == Qt.Key_Escape:
            self.hide()

    def fillInfo(self, item):
        self.contactInfo.setText(item.formattedInfo())
        
    def filterContacts(self, text):
        for item in self.contacts.bodies:
            for val in item.info.values():
                if unicode(text).lower() in val.lower():
                    item.setVisible(True)
                    break
                else:
                    item.setVisible(False)
                    
        f = self.contactList.firstChild()
        if f.isVisible():
            self.contactList.setSelected(f,1)
        else:
            self.contactList.setSelected(f.itemBelow(),1)
                
    def updateListPos(self, i):
        self.contactList.ensureItemVisible(i)
        
    def editContact(self):
        self.hide()
        self.editButton.setDown(False)
        client = KApplication.kApplication().dcopClient()
        if not "kaddressbook" in map(str, client.registeredApplications()):
            os.popen("kaddressbook")
            time.sleep(2)
        kadd = dcopext.DCOPApp("kaddressbook",client)
        uid = self.contactList.selectedItem().info["uid"]
        kadd.KAddressBookIface.showContactEditor(QString(uid))


if __name__ == "__main__":
    
    Contacts()
