#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-


"""
    Copyright (C) 2004 Paul Brauner <polux2001@wanadoo.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
"""



import sys

from qt import *
from kdecore import KApplication, KIconLoader, KAboutData, KCmdLineArgs, KGlobalSettings
from kdeui import KMainWindow, KSystemTray
from contactdialog import contactDialogImpl
import dcopext


class ContactTray(KSystemTray):
    
    def mousePressEvent(self, e):
        
        if e.button() == Qt.LeftButton:
            panR = self.parent().geometry()
            deskR = KGlobalSettings.desktopGeometry(self.parent())
            self.update() # pour tre sr que c sera juste si on vient de bouger la boite  miniatures
            c = self.mapToGlobal(QPoint(0,0))
            
            client = KApplication.kApplication().dcopClient()
            d = dcopext.DCOPApp ("kicker", client)
            res = d.Panel.panelPosition()
            if res[0]:  # si on a russi  rcuprer la position
                pos = res[1]
                res = d.Panel.panelSize()
                if res[0]:
                    taille = res[1]
                else:
                    taille = 0
                
                if pos == 0:
                    c.setX(taille+2);
                elif pos == 1:
                    c.setX(deskR.width()-taille-panR.width()-2);
                elif pos == 2:
                    c.setY(taille+2);
                else:
                    c.setY(deskR.height()-taille-panR.height()-2);

                                  
                if c.y()+panR.height() > deskR.bottom():
                    c.setY(deskR.bottom()-panR.height()-1)
                if c.x()+panR.width() > deskR.right():
                    c.setX(deskR.right()-panR.width()-1)
               
                mainPanel.move(c)
                mainPanel.update()

        KSystemTray.mousePressEvent(self,e)



appName = "Adressbook Light"
version = "1.0"
description = "Light addressbook viewer"
aboutData  = KAboutData (appName, appName, version, description, KAboutData.License_GPL, "(C) 2004 Paul Brauner")   
KCmdLineArgs.init (sys.argv, aboutData)

kapp = KApplication ()
mainPanel = contactDialogImpl()


icons = KIconLoader ()
systray = ContactTray (mainPanel, appName)
icon = systray.loadIcon("kuser")
systray.setPixmap (icon)
systray.contextMenu().changeTitle(systray.contextMenu().idAt(0),appName)
systray.contextMenu().insertItem("update contacts",mainPanel.update)
systray.show ()


## ---- placement de la fentre --------


# rcupration des infos kicker


# ---------------------------------------------



def fin():
    systray.hide()
    kapp.quit()

kapp.connect(systray,SIGNAL("quitSelected()"),fin)
kapp.exec_loop()

